#property indicator_separate_window //  
#property indicator_buffers 6
#property indicator_color1 Blue // 
#property indicator_color2 Magenta //  
#property indicator_color3 Green //  
#property indicator_color4 Red //  
#property indicator_maximum 100
#property indicator_minimum 0

//   MasterSlave
extern int Source=1; // 0 - ; 1 - . ; 2 - ATR; 3 - ; 
extern int SourcePeriod=88; //   
extern int Window=111; //   
extern double Sensitivity=0; // 
extern int Signal=55; //    ()
//   
extern int KperiodFrom=22; //   %K
extern int KperiodTo=5; // 
extern int SlowingFrom=12; //   Slowing
extern int SlowingTo=3; // 
extern int OverSoldFrom=3; //    
extern int OverSoldTo=22; // 

//  
double Stoch[]; // 
double Master[]; //  
double OB[]; //  
double OS[]; //  
double K[]; // % 
double Slow[]; // Slowing 

bool first=1; //    

int init() {
   SetIndexBuffer(0,Stoch); SetIndexStyle(0,DRAW_LINE); SetIndexLabel(0,"Stoch");
   SetIndexBuffer(1,Master); SetIndexStyle(1,DRAW_LINE); SetIndexLabel(1,"Master");
   SetIndexBuffer(2,OB); SetIndexStyle(2,DRAW_LINE,2); SetIndexLabel(2,"OB");
   SetIndexBuffer(3,OS); SetIndexStyle(3,DRAW_LINE,2); SetIndexLabel(3,"OS");
   SetIndexBuffer(4,K); SetIndexStyle(4,DRAW_NONE); SetIndexLabel(4,"%K");
   SetIndexBuffer(5,Slow); SetIndexStyle(5,DRAW_NONE); SetIndexLabel(5,"Slow");
   return(0);
  }

int start() {
   int ic=IndicatorCounted();
   if(!first && Bars-ic>2) ic=reinit(); //        ( )
   
   int limit=Bars-ic-1;
   for(int i=limit; i>=0; i--) {
      //  
      double k=iCustom(NULL,0,"_MasterSlave",Source,SourcePeriod,Window,Sensitivity,Signal, 0,i); Master[i]=100*k;
      //   
      int Kperiod=KperiodFrom+k*(KperiodTo-KperiodFrom); K[i]=Kperiod; // %K 
      int Slowing=SlowingFrom+k*(SlowingTo-SlowingFrom); Slow[i]=Slowing; // Slowing 
      OS[i]=OverSoldFrom+k*(OverSoldTo-OverSoldFrom); OB[i]=100-OS[i]; //  /
      // 
      Stoch[i]=iStochastic(NULL,0,Kperiod,1,Slowing,0,0, 0,i);
     }
   first=0; //    
   return(0);
  }
//+------------------------------------------------------------------+
  
int reinit() { //  
   ArrayInitialize(Stoch,0.0); 
   ArrayInitialize(Master,0.0); 
   ArrayInitialize(OB,0.0); 
   ArrayInitialize(OS,0.0); 
   ArrayInitialize(K,0.0); 
   ArrayInitialize(Slow,0.0); 
   
   return(0);
  }